#include <bits/stdc++.h>

using namespace std;

int main()
{
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    int n;
    cin >> n;
    vector<int> a(n);
    int slucaj4 = true;
    for(int i = 0; i < n; i++){
        cin >> a[i];
        if (slucaj4 && a[i]!= 1 && a[i] != 2){
            slucaj4 = false;
        }

    }
    if(!slucaj4){
        vector<int> uljezi(n);
        if(a[0] > a[1]){
            uljezi[0] = 1;
        }
        for(int i = 1; i < n-1; i++){
            uljezi[i] = uljezi[i-1];
            if (a[i] > a[i+1]){
                uljezi[i]++;
            }
        }
        uljezi[n-1] = uljezi[n-2];
        if(a[n] < a[n-1]){
            uljezi[n-1]++;
        }
        int q;
        cin >> q;
        int l, r;
        for(int i = 0; i < q; i++){
            cin >> l >> r;
            if(l == 1){
                l = 2;
            }
            if(r == 1){
                r = 2;
            }
            if(uljezi[r-2] - uljezi[l-2] > 1){
                cout << "NE" << endl;
            }else{
                cout << "DA" << endl;
            }
        }
    }else{
        vector<int> uljezi(n);
        vector<bool> bUljez(n);
        if(a[0] > a[1]){
            uljezi[0] = 1;
        }
        for(int i = 1; i < n-1; i++){
            uljezi[i] = uljezi[i-1];
            if (a[i] > a[i+1]){
                uljezi[i]++;
                bUljez[i] = true;
            }
        }
        for(int i = 0; i < n; i++){
            if(bUljez[n-i] && !bUljez[n-i-1] && a[n-i-1] == a[n-i]){
                bUljez[n-i-1] = true;
            }
        }
        uljezi[n-1] = uljezi[n-2];
        if(a[n] < a[n-1]){
            uljezi[n-1]++;
        }
        int q;
        cin >> q;
        int l, r, razlika;
        for(int i = 0; i < q; i++){
            cin >> l >> r;
            if(l == 1){
                l = 2;
            }
            if(r == 1){
                r = 2;
            }
            razlika = uljezi[r-2] - uljezi[l-2];
            if(razlika > 1){
                cout << "NE" << endl;
            }else if(razlika == 1 && bUljez[l] && bUljez[l-1]){
                cout << "NE" << endl;
            }else{
                cout << "DA" << endl;
            }
        }
    }

    return 0;
}